#include <stdio.h>
#include <signal.h>

#define TEST(x)  #x ".h"

/* #include TEST(test) */

#define TEST2(format,arg...)  printf(format,arg)

#define siglist(arg...)    char sigs[]={arg}

#define  try(sigl,tryblock,arg...) \
   {\
     sigl;\
     int i; \
     printf ("try("); \
     for (i=0; i<sizeof(sigs); i++) printf("%d ", sigs[i]); \
     printf (") on\n {\n%s\n} catch\n", #tryblock); \
     arg else {} \
  }


#define catch(sign,func)  if (cause==sign) func;


/*
#define catch (sig,func...)  else if (cause==sig) { func ; }
*/

int main ()
{
  try
   (
     siglist(SIGSEGV,SIGFPE,SIGALRM),
     printf ("Hallo");
    {
      int i;
      for (i=0; i<10;i++) printf ("%d\n", i);
    }
    ,
    catch(SIGSEGV, printf("SIGSEGV"),
    catch(SIGFPE,  printf("SIGFPE"),
    catch(SIGALRM, printf("SIGALRM")
   );


  printf ("\n\n");
}

